#include "minigui.ch"

procedure main()
   ***CODIGO DE PAGINA espaol***
   HB_SETCODEPAGE("ESWIN")
   SET LANGUAGE TO SPANISH //Select language for interface messages
   SET DATE FORMAT "dd-mm-yyyy"
   SET EPOCH TO YEAR(DATE())-50

   TituloImp:="Listado de menus"

   DEFINE WINDOW W_Imp1 ;
      AT 10,10 ;
      WIDTH 400 HEIGHT 270 ;
      TITLE 'Imprimir: '+TituloImp ;
      MAIN      ;
      NOSIZE

      @015,10 LABEL L_Version1 VALUE "Version: MiTPRINT v2.3" AUTOSIZE TRANSPARENT
      @035,10 LABEL L_Version2 VALUE "Compilador: "+hb_compiler() AUTOSIZE TRANSPARENT
      @055,10 LABEL L_Version3 VALUE "Lenguaje Programa: "+Version() AUTOSIZE TRANSPARENT
      @075,10 LABEL L_Version4 VALUE MiniGuiVersion() AUTOSIZE TRANSPARENT

draw rectangle in window W_Imp1 at 110,010 to 112,390 fillcolor{255,0,0} //Rojo
      aIMP:=Impresoras("IMPRESORA POR DEFECTO")
      @125,10 LABEL L_Impresora VALUE 'Impresora' AUTOSIZE TRANSPARENT
      @120,100 COMBOBOX C_Impresora WIDTH 280 ;
            ITEMS aIMP[1] VALUE aIMP[3] NOTABSTOP

      @155,220 LABEL L_LibreriaImp VALUE 'Formato' AUTOSIZE TRANSPARENT
      @150,280 COMBOBOX C_LibreriaImp WIDTH 100 ;
            ITEMS aIMP[4] VALUE aIMP[5] NOTABSTOP

      @150, 10 CHECKBOX nImp CAPTION 'Seleccionar impresora' ;
               width 155 value .f. ;
               ON CHANGE W_Imp1.C_Impresora.Enabled:=IF(W_Imp1.nImp.Value=.T.,.F.,.T.)

      @180, 10 CHECKBOX nVer CAPTION 'Previsualizar documento' ;
               width 155 value .T.

      @210, 10 BUTTON B_Imp CAPTION 'Imprimir' WIDTH 90 HEIGHT 25 ;
               ACTION Lis_menus2i()

      @210,110 BUTTON B_OpenOffice CAPTION 'OpenOficce' WIDTH 90 HEIGHT 25 ;
               ACTION Lis_OpenOffice()

      @210,210 BUTTON B_Can CAPTION 'Salir' WIDTH 90 HEIGHT 25 ;
               ACTION W_Imp1.release


      END WINDOW
      CENTER WINDOW W_Imp1
      ACTIVATE WINDOW W_Imp1

Return Nil


STATIC FUNCTION Crear_fichero()
   IF .NOT. FILE("MENUS.DBF")
      aArq:={}
      Aadd( aArq , { 'CODMENU'   , 'N' , 10  , 0 } )
      Aadd( aArq , { 'COMIDA1'   , 'C' , 30  , 0 } )
      Aadd( aArq , { 'COMIDA2'   , 'C' , 30  , 0 } )
      Aadd( aArq , { 'COMIDA3'   , 'C' , 30  , 0 } )
      DBCreate( "MENUS" , aArq  )
      USE MENUS
      FOR N=1 TO 100
         APPEND BLANK
         REPLACE CODMENU WITH N
         REPLACE COMIDA1 WITH "PRIMER PLATO "+LTRIM(STR(N))
         REPLACE COMIDA2 WITH "SEGUNDO PLATO "+LTRIM(STR(N))
         REPLACE COMIDA3 WITH "POSTRE "+LTRIM(STR(N))
      NEXT
   ELSE
      USE MENUS
   ENDIF
RETURN NIL




STATIC FUNCTION Lis_menus2i()
   local oprint

   Crear_fichero()

   oprint:=tprint(UPPER(W_Imp1.C_LibreriaImp.DisplayValue))
   oprint:init()
   oprint:setunits("MM",5) /// unidad de medida , interlineado
   oprint:selprinter(W_Imp1.nImp.value , W_Imp1.nVer.value , .F. , , W_Imp1.C_Impresora.DisplayValue)
   if oprint:lprerror
      oprint:release()
      return nil
   endif
   oprint:begindoc(TituloImp)
   oprint:setpreviewsize(2)  /// tamao del preview  1 menor,2 mas grande ,3 mas...
   oprint:beginpage()

SELEC MENUS
GO TOP
PAG:=0
LIN:=0
DO WHILE .NOT. EOF()
   IF LIN>=275 .OR. PAG=0
      IF PAG<>0
         oprint:printdata(LIN+5,105,"SIGUE EN LA HOJA: "+LTRIM(STR(PAG+1)),"times new roman",10,.F.,,"C",)
         oprint:endpage()
         oprint:beginpage()
      ENDIF
      PAG=PAG+1

      oprint:printdata(20,20,"Suizo Pruebas","times new roman",12,.F.,,"L",)
      oprint:printdata(20,190,"Hoja: "+LTRIM(STR(PAG)),"times new roman",12,.F.,,"R",)
      oprint:printdata(25,20,DATE(),"times new roman",12,.F.,,"L",)

      oprint:printdata(25,105,"Nombre empresa 2006","times new roman",12,.F.,,"C",)
      oprint:printdata(35,105,TituloImp,"times new roman",18,.F.,{255,0,0},"C",)

      LIN:=50
      oprint:printrectangle(LIN-1,20,LIN+4,190,{200,255,200},0.5,{200,255,200} )
      oprint:printdata(LIN, 38,"Codigo"  ,"times new roman",10,.T.,{0,0,255},"R",)
      oprint:printdata(LIN, 40,"1 plato","times new roman",10,.T.,{0,0,255},"L",)
      oprint:printdata(LIN, 90,"2 plato","times new roman",10,.T.,{0,0,255},"L",)
      oprint:printdata(LIN,140,"Postre"  ,"times new roman",10,.T.,{0,0,255},"L",)

      LIN:=LIN+5
   ENDIF

   oprint:printdata(LIN, 38,CodMenu,"times new roman",10,.F.,,"R",)
   oprint:printdata(LIN, 40,Comida1,"times new roman",10,.F.,,"L",)
   oprint:printdata(LIN, 90,Comida2,"times new roman",10,.F.,,"L",)
   oprint:printdata(LIN,140,Comida3,"times new roman",10,.F.,,"L",)

   LIN:=LIN+5
   SKIP

ENDDO

   oprint:printline(LIN+4,20,LIN+4,190,,0.5)

   LIN:=150
   oprint:printdata(LIN, 30,W_Imp1.L_Version1.value,"times new roman",10,.F.,,"L",)
   LIN:=LIN+5
   oprint:printdata(LIN, 30,W_Imp1.L_Version2.value,"times new roman",10,.F.,,"L",)
   LIN:=LIN+5
   oprint:printdata(LIN, 30,W_Imp1.L_Version3.value,"times new roman",10,.F.,,"L",)
   LIN:=LIN+5
   oprint:printdata(LIN, 30,W_Imp1.L_Version4.value,"times new roman",10,.F.,,"L",)

   oprint:endpage()
   oprint:enddoc()
   oprint:RELEASE()

   use

*   W_Imp1.release

Return Nil





STATIC FUNCTION Lis_OpenOffice()
   local oServiceManager,oDesktop,oDocument,oSchedule,oSheet,oCell,oColums,oColumn

   Crear_fichero()

   // inicializa
   oServiceManager := TOleAuto():New("com.sun.star.ServiceManager")
   oDesktop := oServiceManager:createInstance("com.sun.star.frame.Desktop")
   IF oDesktop = NIL
      MsgStop('OpenOffice Calc no esta disponible','error')
      RETURN Nil
   ENDIF
   oDocument := oDesktop:loadComponentFromURL("private:factory/scalc","_blank", 0, {})

   // tomar hoja
   oSchedule := oDocument:GetSheets()

   // tomar primera hoja por nombre oSheet := oSchedule:GetByName("Hoja1")
   // o por indice
   oSheet := oSchedule:GetByIndex(0)

   oSheet:getCellByPosition(0,0):SetString("Suizo Pruebas")
   oSheet:getCellByPosition(0,1):SetString(W_Imp1.L_Version1.value)
   oSheet:getCellByPosition(0,2):SetString(W_Imp1.L_Version2.value)
   oSheet:getCellByPosition(0,3):SetString(W_Imp1.L_Version3.value)
   oSheet:getCellByPosition(0,4):SetString(W_Imp1.L_Version4.value)

   LIN:=6

   oSheet:getCellByPosition(0,LIN):SetString("Codigo")
   oSheet:getCellByPosition(1,LIN):SetString("1 plato")
   oSheet:getCellByPosition(2,LIN):SetString("2 plato")
   oSheet:getCellByPosition(3,LIN):SetString("Postre")
   oSheet:getCellRangeByPosition(0,LIN,0,LIN):HoriJustify:=3
   oSheet:getCellRangeByPosition(0,LIN,3,LIN):CharWeight:=150 //NEGRITA
   aMiColor:={255,255,150} //AMARILLOPALIDO
   oSheet:getCellRangeByPosition(0,LIN,3,LIN):CellBackColor:=RGB(aMiColor[3],aMiColor[2],aMiColor[1])

   LIN++

SELEC MENUS
GO TOP
DO WHILE .NOT. EOF()
   DO EVENTS
   oSheet:getCellByPosition(0,LIN):SetValue(CodMenu)
   oSheet:getCellByPosition(1,LIN):SetString(Comida1)
   oSheet:getCellByPosition(2,LIN):SetString(Comida2)
   oSheet:getCellByPosition(3,LIN):SetString(Comida3)
   oSheet:getCellRangeByPosition(0,LIN,0,LIN):NumberFormat:=4 //#.##0,00

   LIN++
   SKIP

ENDDO

   oColumns:=oSheet:getColumns()
   oColumns:getByIndex(1):setPropertyValue("OptimalWidth", .T.)
   oColumns:getByIndex(2):setPropertyValue("OptimalWidth", .T.)

RETURN NIL


***ESTO LO GUARDO EN UN SOLO FICHERO DEL PROGRAMA***
***SI LO MODIFICO, SE MODIFICA EN TODO EL PROGRAMA***
procedure Impresoras(LLAMADA)
   aIMP1:=aPrinters()
   ASORT(aIMP1,,, { |x, y| UPPER(x) < UPPER(y) })
   aIMP3:=0
   aIMP2:=GetDefaultPrinter()
   aIMP3:=ASCAN(aIMP1, {|aVal| aVal == aIMP2})
   aIMP4:={"MiniPrint","PDFPrint","CalcPrint","ExcelPrint","HTMLPrint","CSVPrint","RTFPrint","DosPrint"}
   aIMP5:=1
   aIMP:={aIMP1,aIMP2,aIMP3,aIMP4,aIMP5}
RETURN(aIMP)
*aIMP1:=array de impresoras
*aIMP2:=nombre de la impresora por defecto
*aIMP3:=numero de la impresora por defecto
*aIMP4:=array de librerias
*aIMP5:=libreria seleccionada por defecto



***libreria***
#include "tprinto.prg"
#include "TprintPDF.prg"
